package addbk.midtermAddressBook;

import java.awt.*;
import java.io.*;
import java.util.Vector;
import java.beans.XMLEncoder;

public class AddressBookCollection
    implements Serializable {
  private Vector addressVector = new Vector();
  private int recordNumber = 0; // The current record's number.

  public AddressBookCollection() {
    // addRecord(new AddressRecord());
  }

  public String toString() {
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    XMLEncoder e = new XMLEncoder(baos);
    e.writeObject(this);
    e.flush();
    return baos.toString();
  }

  public void sort() {
    //System.out.println("sorting");
    //***** Un comment on JDK 1.2 or better to sort
     //Collections.sort(v);
  }

  public addbk.midtermAddressBook.AddressRecord getEmptyRecord() {
    addbk.midtermAddressBook.AddressRecord ar = new addbk.midtermAddressBook.AddressRecord();
    ar.setFirstName("");
    ar.setLastName("");
    ar.setAddress1("");
    ar.setAddress2("");
    ar.setPhone1("");
    ar.setPhone2("");
    ar.setPhone3("");
    return (ar);
  }


  public addbk.midtermAddressBook.AddressRecord readRecord() {
    return (addbk.midtermAddressBook.AddressRecord) addressVector.elementAt(recordNumber);
  }

  public AddressRecord readRecord(int recNumber) {
    return (AddressRecord) addressVector.elementAt(recNumber);
  }

  public void addRecord(AddressRecord ar) {
    addressVector.addElement(ar);
    recordNumber = addressVector.size() - 1;
  }

  public void deleteRecord(AddressRecord ar) {
    addressVector.removeElement(ar);
  }

  public void saveCurrentRecord(AddressRecord ar) throws ArrayIndexOutOfBoundsException {

      addressVector.setElementAt(ar, recordNumber);

  }

  public int getNumRecords() {
    return (addressVector.size());
  }

  public int getRecPosition() {
    return recordNumber;
  }

  public void deleteCurrentRecord() {
    addressVector.removeElementAt(recordNumber);
  }

  public void incrementRecord() {
    if (recordNumber < (addressVector.size() - 1))
      recordNumber++;
    System.out.println(recordNumber);
  }

  public void decrementRecord() {
    if (recordNumber > 0)
      recordNumber--;
    System.out.println(recordNumber);
  }

  public void setRecordNumber(int index) {
    if ( (index >= 0) && (index <= addressVector.size()))
      recordNumber = index;
    System.out.println(recordNumber);
  }

  public void writeToFile() throws IOException {
    FileOutputStream outStream = new FileOutputStream("junkobj");
    System.out.println("FileOutputStream OK");
    ObjectOutputStream ooStream = new ObjectOutputStream(outStream);
    System.out.println("ObjectOutputStream OK");
    ooStream.writeObject(this);
    ooStream.flush();
    ooStream.close();
    outStream.close();
  } // writeToFile()

  public Vector getAddressVector() {
    return addressVector;
  }

  public void setAddressVector(Vector addressVector) {
    this.addressVector = addressVector;
  }

  static class Futil {
    public static String getReadFileName(
        String prompt) {
      FileDialog fd = new FileDialog(
          new Frame(), prompt);
      fd.setVisible(true);
      fd.setVisible(false);
      return fd.getDirectory() + fd.getFile();
    }

    public static String getWriteFileName(
        String prompt) {
      FileDialog fd = new FileDialog(
          new Frame(), prompt, FileDialog.SAVE);
      fd.setVisible(true);
      fd.setVisible(false);
      return fd.getDirectory() + fd.getFile();
    }
  }

}
